SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 5/22/2012 00:06'!
centimeter
	
	^DistanceUnit centimeters.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 5/22/2012 00:06'!
decameter
	
	^DistanceUnit decameters.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 5/22/2012 00:06'!
decimeter
	
	^DistanceUnit decimeters.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 5/22/2012 00:26'!
hectometer
	
	^DistanceUnit hectometers.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 5/22/2012 00:26'!
kilometer
	
	^DistanceUnit kilometers.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 5/22/2012 00:07'!
meter

	^DistanceUnit meters.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 5/22/2012 00:08'!
millimeter
	
	^DistanceUnit millimeters.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 19:32'!
minusOneMeter 
	
	^DistanceMeasure inMetersWithAMagnitudeOf: -1.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 19:32'!
oneCentimeter
	
	^DistanceMeasure inCentimetersWithAMagnitudeOf: 1.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 19:32'!
oneHundredCentimeters
	
	^DistanceMeasure inCentimetersWithAMagnitudeOf: 100.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 19:32'!
oneMeter
	
	^DistanceMeasure inMetersWithAMagnitudeOf: 1.! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 15:04'!
test01ObjectsRepresentingSameDistanceShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GuillermoAres 5/22/2012 00:59'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GuillermoAres 5/22/2012 01:00'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GuillermoAres 5/22/2012 00:23'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter magnitude = 1.
	self assert: self twoMeters magnitude = 2.
	self assert: self oneHundredCentimeters magnitude = 100.
	self assert: self twoHundredCentimeters magnitude = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07bDistanceUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GuillermoAres 5/22/2012 00:30'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance expressedIn: self meter) magnitude = 1.
		self assert: (aDistance expressedIn: self meter) unit = self meter.
		
		self assert: (aDistance expressedIn: self decimeter) magnitude = 10.
		self assert: (aDistance expressedIn: self decimeter) unit = self decimeter.
		
		self assert: (aDistance expressedIn: self centimeter) magnitude = 100.
		self assert: (aDistance expressedIn: self centimeter) unit = self centimeter.
		
		self assert: (aDistance expressedIn: self millimeter) magnitude = 1000.
		self assert: (aDistance expressedIn: self millimeter) unit = self millimeter.
	
		self assert: (aDistance expressedIn: self decameter) magnitude = (1/10).
		self assert: (aDistance expressedIn: self decameter) unit = self decameter.
		
		self assert: (aDistance expressedIn: self hectometer) magnitude = (1/100).
		self assert: (aDistance expressedIn: self hectometer) unit = self hectometer.
	
		self assert: (aDistance expressedIn: self kilometer) magnitude = (1/1000).
		self assert: (aDistance expressedIn: self kilometer) unit = self kilometer ]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 5/22/2012 01:31'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) magnitude = (2/3).
	self assert: (self twoMeters * (2/3)) magnitude = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 5/22/2012 01:31'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) magnitude = 2.5.
	self assert: (self twoMeters * 2.5) magnitude = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:48'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 5/22/2012 00:23'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) magnitude = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 5/22/2012 00:23'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) magnitude = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GuillermoAres 5/22/2012 01:33'!
test21DistancesProvideATotalOrder

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GuillermoAres 5/22/2012 01:34'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distanceExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GuillermoAres 5/22/2012 01:36'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GuillermoAres 5/22/2012 01:37'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by=self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.	
	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GuillermoAres 5/22/2012 00:23'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance magnitude = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GuillermoAres 5/22/2012 00:23'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance magnitude.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance magnitude = value.
		value := value + byDistance magnitude ].
	
	self assert:  value = (finalDistance magnitude + byDistance magnitude)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 19:32'!
twoHundredCentimeters
	
	^DistanceMeasure inCentimetersWithAMagnitudeOf: 200.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 19:32'!
twoMeters
	
	^DistanceMeasure inMetersWithAMagnitudeOf: 2.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 19:32'!
zeroMeters

	^DistanceMeasure inMetersWithAMagnitudeOf: 0.! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'HernanWilkinson 4/25/2011 17:22'!
canNotConvertMeasurementException
	
	self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:22'!
celsius
	
	self error: 'Este metodo debe devolver un objeto que la unidad de temperatura Celsius'! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 16:03'!
centimeter
	
	self error: 'Este metodo debe devolver el objeto que la unidad de distancia centimetro'! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/25/2011 17:22'!
day
	
	self error: 'Este metodo debe devolver un objeto que represente la unidad dia'! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 16:03'!
decameter
	
	self error: 'Este metodo debe devolver el objeto que la unidad de distancia decametro'! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 16:03'!
decimeter
	
	self error: 'Este metodo debe devolver el objeto que la unidad de distancia decimetro'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
eightCubicMeters

	^self error: 'este metodo debe devolver la medida 8 metros cubicos'! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:22'!
fahrenheit
	
	self error: 'Este metodo debe devolver un objeto que represente la unidad de temperatura Fahrenheit'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:40'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
fourSquaredMeters

	^self error: 'este metodo debe devolver la medida 4 metros cuadrados'! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 16:03'!
hectometer
	
	self error: 'Este metodo debe devolver el objeto que la unidad de distancia hectometro'! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/25/2011 17:22'!
hour
	
	self error: 'Este metodo debe devolver un objeto que represente la unidad hora'! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:29'!
kelvin
	
	self error: 'Este metodo debe devolver un objeto que represente la unidad de temperatura Kelvin'! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 16:03'!
kilometer
	
	self error: 'Este metodo debe devolver el objeto que la unidad de distancia kilometro'! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 16:03'!
meter

	self error: 'Este metodo debe devolver el objeto que la unidad de distancia metro'! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 16:03'!
millimeter
	
	self error: 'Este metodo debe devolver el objeto que la unidad de distancia millimetro'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 16:03'!
minusOneMeter 
	
	self error: 'Este metodo debe devolver un objeto que represente un metro'! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/25/2011 17:22'!
minute
	
	self error: 'Este metodo debe devolver un objeto que represente la unidad minuto'! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AresJamardo 5/30/2012 20:03'!
oneCelsius
	
	^TemperatureMeasure inCelsiusWithAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 16:03'!
oneCentimeter
	
	self error: 'Este metodo debe devolver un objeto que represente un centimetro'! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:22'!
oneDay
	
	self error: 'Este metodo debe devolver un objeto que represente un dia'! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:22'!
oneHour
	
	self error: 'Este metodo debe devolver un objeto que represente una hora'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 20:11'!
oneHundredCentimeters
	
	^DistanceMeasure inCentimetersWithAMagnitudeOf: 100.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'efo 5/2/2011 20:56'!
oneHundredTwentyOneMetersPerSecond

	^self error: 'este metodo debe devolver la medida 121 metro/segundo'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 19:32'!
oneMeter
	
	^DistanceMeasure inMetersWithAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:36'!
oneMeterPerSecond

	^self error: 'este metodo debe devolver la medida 1 metro/segundo'! !

!MeasureTest methodsFor: 'time measures' stamp: 'AresJamardo 5/30/2012 20:12'!
oneMinute
	
	^TimeMeasure inMinutesWithAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'time measures' stamp: 'AresJamardo 5/30/2012 19:23'!
oneSecond

	^TimeMeasure inSecondsWithAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:37'!
oneSquaredMeter

	^self error: 'este metodo debe devolver la medida 1 metro cuadrado'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:36'!
oneSquaredSecond

	^self error: 'este metodo debe devolver la medida 1 segundo cuadrado'! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/25/2011 17:22'!
second
	
	self error: 'Este metodo debe devolver un objeto que represente la unidad segundo'! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:22'!
sixtyMinutes
	
	self error: 'Este metodo debe devolver un objeto que represente sesenta minutos'! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:22'!
sixtyOneSeconds
	
	self error: 'Este metodo debe devolver un objeto que represente sesenta y un segundos'! !

!MeasureTest methodsFor: 'time measures' stamp: 'AresJamardo 5/30/2012 20:09'!
sixtySeconds
	
	^TimeMeasure inSecondsWithAMagnitudeOf: 60.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:11'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:13'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celcius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AresJamardo 5/30/2012 20:23'!
thirtyTwoFahrenheits
	
	^TemperatureMeasure inFahrenheitsWithAMagnitudeOf: 32.! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:22'!
twentyFourHours
	
	self error: 'Este metodo debe devolver un objeto que represente veinticuatros horas'! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:22'!
twoCelsius
	
	self error: 'Este metodo debe devolver un objeto que represente dos grados centigrados'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 20:11'!
twoHundredCentimeters
	
	^DistanceMeasure inCentimetersWithAMagnitudeOf: 200.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AresJamardo 5/30/2012 20:09'!
twoMeters
	
	^DistanceMeasure inMetersWithAMagnitudeOf: 2.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
twoMetersBySecond

	^self error: 'este metodo debe devolver la medida 2 metros/segundo'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:33'!
twoMetersPerSquaredSecond

	^self error: 'este metodo debe devolver la medida 2 metros/segundoAlCuadrado'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:33'!
twoMetersTimesSecond

	^self error: 'este metodo debe devolver la medida 2 metros*segundo'! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:22'!
twoSeconds
	
	self error: 'Este metodo debe devolver un objeto que represente dos segundos'! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AresJamardo 5/30/2012 20:10'!
zeroCelsius
	
	^TemperatureMeasure inCelsiusWithAMagnitudeOf: 0.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:31'!
zeroKelvin
	
	self error: 'Este metodo debe devolver un objeto que represente cero kelvin'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 16:03'!
zeroMeters

	self error: 'Este metodo debe devolver un objeto que represente cero metros'! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:22'!
zeroSeconds
	
	self error: 'Este metodo debe devolver un objeto que represente cero segundos'! !

Object subclass: #IntervaI
	instanceVariableNames: 'from to by'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

IntervaI subclass: #DistanceInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceInterval class methodsFor: 'instance creation' stamp: 'AresJamardo 5/30/2012 19:32'!
from: aBound to: anotherBound 
	^self new from: aBound; to: anotherBound; by: (DistanceMeasure in: aBound unit withAMagnitudeOf: 1).! !

!DistanceInterval class methodsFor: 'instance creation' stamp: 'GuillermoAres 5/22/2012 02:22'!
from: aBound to: anotherBound by: aStepDistance
	^(self from: aBound to: anotherBound) by: aStepDistance.! !

!IntervaI methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:45'!
by
	
	^by! !

!IntervaI methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:45'!
by: aStepDistance

	by := aStepDistance.! !

!IntervaI methodsFor: 'enumerating' stamp: 'AresJamardo 5/30/2012 19:46'!
do: aBlockClosure 

	| actualValue lowerBound upperBound  |
	lowerBound := to min: from.
	upperBound := to max: from.
	
	actualValue := lowerBound.
	
	[actualValue <= upperBound] whileTrue: 
									[ aBlockClosure value: actualValue. 
										actualValue := actualValue + by].! !

!IntervaI methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:46'!
from

	^ from! !

!IntervaI methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:45'!
from: aBound

	from := aBound.! !

!IntervaI methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:45'!
size
	
	^(to - from expressedIn: by unit) magnitude / by magnitude + 1.! !

!IntervaI methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:45'!
to

	^ to! !

!IntervaI methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:45'!
to: aBound 
	to := aBound.! !

Object subclass: #Measure
	instanceVariableNames: 'unit magnitude'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Measure subclass: #DistanceMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceMeasure class methodsFor: 'instance creation with known distance units' stamp: 'GuillermoAres 5/22/2012 00:36'!
inCentimetersWithAMagnitudeOf: aMagnitude

	^self new unit: (DistanceUnit centimeters); magnitude: aMagnitude.! !

!DistanceMeasure class methodsFor: 'instance creation with known distance units' stamp: 'GuillermoAres 5/22/2012 00:36'!
inDecametersWithAMagnitudeOf: aMagnitude

	^self new unit: (DistanceUnit decameters); magnitude: aMagnitude.! !

!DistanceMeasure class methodsFor: 'instance creation with known distance units' stamp: 'GuillermoAres 5/22/2012 00:37'!
inDecimetersWithAMagnitudeOf: aMagnitude

	^self new unit: (DistanceUnit decimeters); magnitude: aMagnitude.! !

!DistanceMeasure class methodsFor: 'instance creation with known distance units' stamp: 'GuillermoAres 5/22/2012 00:37'!
inHectometersWithAMagnitudeOf: aMagnitude

	^self new unit: (DistanceUnit hectometers); magnitude: aMagnitude.! !

!DistanceMeasure class methodsFor: 'instance creation with known distance units' stamp: 'GuillermoAres 5/22/2012 00:37'!
inKilometersWithAMagnitudeOf: aMagnitude

	^self new unit: (DistanceUnit kilometers); magnitude: aMagnitude.! !

!DistanceMeasure class methodsFor: 'instance creation with known distance units' stamp: 'GuillermoAres 5/22/2012 00:37'!
inMetersWithAMagnitudeOf: aMagnitude

	^self new unit: (DistanceUnit meters); magnitude: aMagnitude.! !

!DistanceMeasure class methodsFor: 'instance creation with known distance units' stamp: 'GuillermoAres 5/22/2012 00:37'!
inMillimetersWithAMagnitudeOf: aMagnitude

	^self new unit: (DistanceUnit millimeters); magnitude: aMagnitude.! !

!Measure class methodsFor: 'instance creation' stamp: 'AresJamardo 5/30/2012 19:58'!
in: aUnit withAMagnitudeOf: aMagnitude

	^self new unit: aUnit; magnitude: aMagnitude.! !

!Measure methodsFor: 'arithmetic' stamp: 'AresJamardo 5/30/2012 19:47'!
* anInteger 
	^DistanceMeasure in: self unit withAMagnitudeOf: self magnitude * anInteger.! !

!Measure methodsFor: 'arithmetic' stamp: 'AresJamardo 5/30/2012 19:47'!
+ anotherDistance 

	| resultingDistance |
	resultingDistance := self expressedIn: anotherDistance unit.
	resultingDistance magnitude: resultingDistance magnitude + anotherDistance magnitude.
	^resultingDistance! !

!Measure methodsFor: 'arithmetic' stamp: 'AresJamardo 5/30/2012 19:49'!
- anotherDistance 
	| resultingDistance |
	resultingDistance := self expressedIn: anotherDistance unit. 
	resultingDistance magnitude: resultingDistance magnitude  - anotherDistance magnitude.
	^resultingDistance.! !

!Measure methodsFor: 'arithmetic' stamp: 'AresJamardo 5/30/2012 19:49'!
/ anInteger 
	^DistanceMeasure in: self unit withAMagnitudeOf: self magnitude / anInteger.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:47'!
< anotherDistance
	^(self expressedIn: anotherDistance unit) magnitude < anotherDistance magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:47'!
<= anotherDistance 
	^(self expressedIn: anotherDistance unit) magnitude <= anotherDistance magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:49'!
= aDistance

	(self == aDistance) ifTrue:  [^true].
	self class name = aDistance class name ifFalse: [^false].

	^(self expressedIn: DistanceUnit meters) magnitude = (aDistance expressedIn: DistanceUnit meters) magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:49'!
> anotherDistance 
	^(self expressedIn: anotherDistance unit) magnitude > anotherDistance magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:49'!
>= anotherDistance
	^(self expressedIn: anotherDistance unit) magnitude >= anotherDistance magnitude.! !

!Measure methodsFor: 'intervals' stamp: 'AresJamardo 5/30/2012 19:49'!
between: aLowerBound and: anUpperBound

	^aLowerBound < self and: self < anUpperBound.! !

!Measure methodsFor: 'conversion' stamp: 'AresJamardo 5/30/2012 21:04'!
expressedIn: theNewUnit

	^(self conversionFunctionTo: theNewUnit) value: self.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:47'!
hash
	
	^(self expressedIn: DistanceUnit meters) magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:49'!
isZero
	^magnitude = 0.! !

!Measure methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:48'!
magnitude

	^ magnitude! !

!Measure methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:48'!
magnitude: aSmallInteger 

	magnitude := aSmallInteger! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:48'!
max: anotherDistance
	^self >= anotherDistance ifTrue: self ifFalse: anotherDistance.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:48'!
min: anotherDistance 
	^self <= anotherDistance ifTrue: self ifFalse: anotherDistance.! !

!Measure methodsFor: 'arithmetic' stamp: 'AresJamardo 5/30/2012 19:47'!
negated
	magnitude := magnitude negated! !

!Measure methodsFor: 'printing' stamp: 'AresJamardo 5/30/2012 19:47'!
printOn: aStream

	self magnitude printOn: aStream.
	aStream nextPutAll: ' '; nextPutAll: self unit name.
	magnitude > 1 ifTrue: [aStream nextPutAll: 's'].! !

!Measure methodsFor: 'intervals' stamp: 'AresJamardo 5/30/2012 19:49'!
to: aDistance 
	^DistanceInterval from: self to: aDistance.! !

!Measure methodsFor: 'intervals' stamp: 'AresJamardo 5/30/2012 19:48'!
to: aBound by: aStepDistance 
	^DistanceInterval from: self to: aBound by: aStepDistance.! !

!Measure methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:48'!
unit

	^ unit! !

!Measure methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:48'!
unit: aDistanceUnit 

	unit := aDistanceUnit! !

Measure subclass: #TemperatureMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureMeasure class methodsFor: 'instance creation with known units' stamp: 'AresJamardo 5/30/2012 20:06'!
inCelsiusWithAMagnitudeOf: aMagnitude 

	^self new unit: (TemperatureUnit celsius); magnitude: aMagnitude.! !

!TemperatureMeasure class methodsFor: 'instance creation with known units' stamp: 'AresJamardo 5/30/2012 20:27'!
inFahrenheitsWithAMagnitudeOf: aMagnitude 
	
	^TemperatureMeasure in: TemperatureUnit fahrenheits withAMagnitudeOf: 1.! !

Measure subclass: #TimeMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeMeasure class methodsFor: 'instance creation with known time units' stamp: 'AresJamardo 5/30/2012 20:21'!
inMinutesWithAMagnitudeOf: aMagnitude 

	^TimeMeasure in: TimeUnit minutes withAMagnitudeOf: 1.! !

!TimeMeasure class methodsFor: 'class initialization' stamp: 'AresJamardo 5/30/2012 19:26'!
inSecondsWithAMagnitudeOf: aMagnitude

	^self new unit: (TimeUnit seconds); magnitude: aMagnitude.! !

Object subclass: #Unit
	instanceVariableNames: 'name toReferenceUnitConversionFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit subclass: #DistanceUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 21:21'!
centimeters

	^DistanceUnit named: 'centimeter' withTheToReferenceUnitConversionFunctionOf: [:aMeasure | aMeasure * 1/100].
! !

!DistanceUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
decameters
	^DistanceUnit named: 'decameter' withTheToReferenceUnitConversionFunctionOf: 10.! !

!DistanceUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
decimeters
	^DistanceUnit named: 'decimeter' withTheToReferenceUnitConversionFunctionOf: 1/10.! !

!DistanceUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
hectometers
	^DistanceUnit named: 'hectometer' withTheToReferenceUnitConversionFunctionOf: 100.! !

!DistanceUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
kilometers
	^DistanceUnit named: 'kilometer' withTheToReferenceUnitConversionFunctionOf: 1000.! !

!DistanceUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
meters
	^DistanceUnit named: 'meter' withTheToReferenceUnitConversionFunctionOf: 1.! !

!DistanceUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
millimeters
	^DistanceUnit named: 'millimeter' withTheToReferenceUnitConversionFunctionOf: 1/1000.! !

Unit subclass: #TemperatureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
celsius
	
	^TemperatureUnit named: 'celcius' withTheToReferenceUnitConversionFunctionOf: 1.! !

!TemperatureUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
fahrenheits
	^TemperatureUnit withTheToReferenceUnitConversionFunctionOf: 1.! !

Unit subclass: #TimeUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeUnit class methodsFor: 'known units creation' stamp: 'AresJamardo 5/30/2012 20:33'!
minutes

	^TimeUnit withTheToReferenceUnitConversionFunctionOf: 60.! !

!TimeUnit class methodsFor: 'class initialization' stamp: 'AresJamardo 5/30/2012 20:33'!
seconds

	^TimeUnit named: 'Second' withTheToReferenceUnitConversionFunctionOf: 1.! !

!Unit class methodsFor: 'instance creation' stamp: 'AresJamardo 5/30/2012 20:33'!
named: unitName withTheToReferenceUnitConversionFunctionOf: aConversionFunction
	
	^(DistanceUnit withTheToReferenceUnitConversionFunctionOf: aConversionFunction) name: unitName.! !

!Unit class methodsFor: 'instance creation' stamp: 'AresJamardo 5/30/2012 20:33'!
withTheToReferenceUnitConversionFunctionOf: aToReferenceUnitConversionFactor
	
	^self new toReferenceUnitConversionFunction: aToReferenceUnitConversionFactor.! !

!Unit methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 20:52'!
= anotherUnit
	
	^(self class = anotherUnit class) and: (self toReferenceUnitConversionFunction value: 1 = anotherUnit toReferenceUnitConversionFunction value: 1).! !

!Unit methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 21:02'!
conversionFunctionTo: anotherUnit

	^[:aMeasure | anotherUnit fromReferenceUnitConversionFunction value: (self toReferenceUnitConversionFunction value: aMeasure)]! !

!Unit methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:37'!
name
	^ name! !

!Unit methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:38'!
name: anObject
	name := anObject! !

!Unit methodsFor: 'printing' stamp: 'AresJamardo 5/30/2012 19:40'!
printOn: aStream

	aStream
		nextPutAll: self name.! !

!Unit methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 20:29'!
toReferenceUnitConversionFunction

	^toReferenceUnitConversionFunction.
	! !

!Unit methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 20:30'!
toReferenceUnitConversionFunction: aConversionFunction

	toReferenceUnitConversionFunction  := aConversionFunction.! !
